config/routes.rb
Rails.application.routes.draw do

  # Serve websocket cable requests in-process
  # mount ActionCable.server => '/cable'

  root 'store#home', as: 'store_home'

  get 'info/index'
  get 'store/index'

  get "all_users_path" => "users#index"

  get 'admin' => 'admin#index'
  get "/products/show/" => "products#one"
  get "/store/filter" => "store#filterProducts"
  get "/orders/o" => "orders#one"

  controller :sessions do
    get 'login' => :new
    post 'login' => :create
    delete 'logout' => :destroy
    get 'logout' => :destroy
  end

  resources :users
  resources :orders
  resources :line_items
  resources :carts

  resources :products do
    get :who_bought, on: :member
  end

  resources :line_items do
    put 'decrease', on: :member
    put 'increase', on: :member
  end


  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/product.rb
class Product < ApplicationRecord
  has_many :line_items
  has_many :orders, through: :line_items

  enum prod_types: {
    "Books" => 0,
    "Sunglasses" => 1,
    "Other" => 2
  }

  before_destroy :ensure_not_referenced_by_any_line_item
  before_update :changeType
  validates :title, :description, presence: true
  validates :price, numericality: {greater_than_or_equal_to: 0.01}
  validates :title, uniqueness: true
  validates :image_url, allow_blank: true, format: {
      with: %r{\.(gif|jpg|png)\Z}i,
      message: 'must be a URL for GIF, JPG or PNG image.'
  }

  private
    # ensure that there are no line items referencing this product
    def ensure_not_referenced_by_any_line_item
      unless line_items.empty?
        errors.add(:base, 'Line Items present')
        throw :abort
    end
  end

  def changeType
    self.prod_type = "Books"
  end
end

app/controllers/products_controller.rb
class ProductsController < ApplicationController
  before_action :set_product, only: [:show, :edit, :update, :destroy]
  skip_before_action :authorize, only: :one
  layout "admin_application", except: :one

  include CurrentCart
  before_action :set_cart

  # GET /products
  # GET /products.json
  def index
    @products = Product.all
  end

  # GET /products/1
  # GET /products/1.json
  def show
  end

  def one
    @product = Product.find(params[:id])
  end

  # GET /products/new
  def new
    @product = Product.new
  end

  # GET /products/1/edit
  def edit
  end

  # POST /products
  # POST /products.json
  def create
    @product = Product.new(product_params)

    respond_to do |format|
      if @product.save
        format.html { redirect_to products_url }
        format.js
        format.json { render :show, status: :created, location: @product }
      else
        format.html { render :new }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  def who_bought
    @product = Product.find(params[:id])
    @latest_order = @product.orders.order(:updated_at).last
    if stale?(@latest_order)
      respond_to do |format|
        format.atom
      end
    end
  end

  # PATCH/PUT /products/1
  # PATCH/PUT /products/1.json
  def update
    respond_to do |format|
      if @product.update(product_params)
        format.html { redirect_to @product, notice: 'Product was successfully updated.' }
        format.json { render :show, status: :ok, location: @product }

        # @products = Product.all
        # ActionCable.server.broadcast 'products',
          # html: render_to_string('store/index', layout: false)
      else
        format.html { render :edit }
        format.json { render json: @product.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /products/1
  # DELETE /products/1.json
  def destroy
    if @product.destroy
      message = "Product was successfully destroyed."
    else
      message = "Product could not be deleted, because is added to cart."
    end

    respond_to do |format|
      format.html { redirect_to products_url, :notice => message }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_product
      @product = Product.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def product_params
      params.require(:product).permit(:title, :description, :image_url, :price, :prod_type)
    end
end

app/helpers/products_helper.rb
module ProductsHelper
end

app/views/products/_form.html.erb
<%= form_for(product) do |f| %>
  <% if product.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(product.errors.count, "error") %> prohibited this product from being saved:</h2>

      <ul>
      <% product.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :title %>
    <%= f.text_field :title %>
  </div>

  <div class="field">
    <%= f.label :description %>
    <%= f.text_area :description, rows: 4, cols: 50 %>
  </div>

  <div class="field">
    <%= f.label :prod_type %>
    <%= f.select :prod_type, Product.prod_types.keys,
                  prompt: 'Select product type' %>
  </div>

  <!-- <div class="field">
    <%= f.label :image_url %>
    <%= f.text_field :image_url %>
  </div> -->

  <div class="field">
    <%= f.label :price %>
    <%= f.text_field :price, size: 13 %> (€)
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/products/edit.html.erb
<h2 class="product_header">Editing Product</h2>

<div class="products_column">

<%= render 'form', product: @product %>

<!-- <%= link_to 'Show', @product %> | -->
<div class="back_button">
<%= link_to 'Back', products_path %>
</div>
</div>

app/views/products/index.html.erb
<p id="notice"><%= notice %></p>

  <h2 class="product_header" id="Products">Products</h2>

  <div class="products_column">

  <p id="new_product_div">
    <%= link_to 'New product', new_product_path %>
  </p>

  <table>
    <thead>
      <tr>
        <th></th>
        <th></th>
        <th></th>
        <th></th>
        <th colspan="3"></th>
      </tr>
    </thead>

    <% @products.each do |product| %>
    <tr id="<%= product.title %>">
      <td>
        <% if (product.image_url != nil) %>
          <%= image_tag(product.image_url, class: 'list_image') %>
        <% end %>
      </td>
      <td class="list_description">
        <%= link_to product.title, product, action: "show" %>
        <div class="categ_div">Category: <span class="prod_categ"><%= product.prod_type %></span></div>
      </td>
      <td class="list_actions"><%= link_to 'Edit', edit_product_path(product) %></td>
      <td class="list_actions"><%= link_to 'Delete', product, method: :delete %></td>
    </tr>

    <% end %>
  </table>

</div>

<br />

app/views/products/new.html.erb
<h2 class="product_header">New Product</h2>

<div class="products_column">

<%= render 'form', product: @product %>

<div class="back_button">
<%= link_to 'Back', products_path %>
</div>
</div>

app/views/products/one.html.erb
<p id="notice"><%= notice %></p>

<div class="one_product_page">

  <p>
    <% if (@product.image_url != nil) %>
      <%= image_tag(@product.image_url, class: 'list_image') %>
    <% end %>
  </p>

  <p>
    <h2>
      <!-- Title:  -->
      <%= @product.title %>
    </h2>
  </p>

  <p>
    <strong>Description:</strong>
    <%= strip_tags(@product.description) %>
  </p>

  <p>
    <strong>Type:</strong>
    <%= @product.prod_type %>
  </p>

  <p>
    <strong>Price:</strong>
    <%= number_to_currency(@product.price) %>
  </p>

  <%= button_to 'Add to Cart', line_items_path(product_id: @product), remote: true %>

</div>

app/views/products/show.html.erb
<p id="notice"><%= notice %></p>

<div class="products_column">

<p>
  <% if (@product.image_url != nil) %>
    <%= image_tag(@product.image_url, class: 'list_image') %>
  <% end %>
</p>

<p>
  <strong>Title:</strong>
  <%= @product.title %>
</p>

<p>
  <strong>Description:</strong>
  <%= strip_tags(@product.description) %>
</p>

<p>
  <strong>Type:</strong>
  <%= @product.prod_type %>
</p>

<p>
  <strong>Price:</strong>
  <%= number_to_currency(@product.price) %>
</p>

<!-- <%= button_to 'Add to Cart', line_items_path(product_id: @product), remote: true %> -->


<div class="back_button">
  <%= link_to 'Edit', edit_product_path(@product) %> | 
  <%= link_to 'Back', products_path %>
</div>

</div>